{-| Module  : FiniteCategories
Description : Six examples of 'DiscreteCategory' pretty printed.
Copyright   : Guillaume Sabbagh 2022
License     : GPL-3
Maintainer  : guillaumesabbagh@protonmail.com
Stability   : experimental
Portability : portable

Six examples of 'DiscreteCategory' pretty printed.

Pretty print categories __0__ up to __5__ .
-}
module Math.FiniteCategories.DiscreteCategory.Example
(
    main
)
where
    import Data.WeakSet.Safe
    
    import Math.FiniteCategories.DiscreteCategory
    import Math.IO.PrettyPrint
    import Math.FiniteCategory
    
    -- | Six examples of 'DiscreteCategory' pretty printed.
    main :: IO ()
    main = do
        putStrLn "Start of Math.FiniteCategories.DiscreteCategory.Example"
        let cats = discreteCategory <$> (\n -> set (take n ['A'..])) <$> [0..5]
        let ps = (putStrLn.pprintFiniteCategory) <$> cats
        sequence ps
        putStrLn "End of Math.FiniteCategories.DiscreteCategory.Example"